program atomsbmt

use io
use images

implicit none

type(bmp)            :: b
real*8               :: a1,a2,dx(3,3),r,r2,x,y,v(3)
type(geo)            :: g
character(len=20)    :: fi,fo
integer              :: iunit,l,h,cerchio(1000,2),nc
integer              :: i,j,ir,vi(3),ii,jj,ic(2)
integer, allocatable :: c(:,:,:)

r=9.5/2.d0
r2=r*r
fi="pos.xyz"
fo="pos.bmp"
read*, a1,a2
iunit=7
call read_geo(g,fi,iunit)
l=400
h=nint((1.d0*l)/a1*a2)
print*,l,h
allocate(c(l,h,3))
c=255
dx=0.d0
dx(1,1)=a1/l
dx(2,2)=a2/h
dx(3,3)=1
nc=0
ir=nint(r/dx(1,1))
do i=-ir,ir
 do j=-ir,ir
  x=(i-1)*dx(1,1)
  y=(j-1)*dx(2,2)
  if(x*x+y*y.le.r2) then
  nc=nc+1
  cerchio(nc,1)=i
  cerchio(nc,2)=j
  endif
 enddo
enddo
do i=1,g%n
 select case(g%name(i)(1:1))
  case("O")
  ic(1)=2
  ic(2)=3
  case("N")
  ic(1)=1
  ic(2)=2
 end select
 v=g%p(i,1:3)
 call ijk(vi,v,dx)
 do j=1,nc
  ii=cerchio(j,1)+vi(1)
  if(ii.gt.l)ii=ii -ii/l *l
  if(ii.le.0)ii=ii -((ii/l-1) *l)
  jj=cerchio(j,2)+vi(2)
  jj=jj -jj/h *h
  if(jj.gt.h)jj=jj -jj/h *h
  if(jj.le.0)jj=jj -((jj/h-1) *h)
  c(ii,jj,ic(1))=0
  c(ii,jj,ic(2))=0
! print*,ii,jj,c(ii,jj,1:3)
 enddo
enddo

open(unit=iunit,file=fo,status="unknown")

call make_bmp(b,c)
call write_bmp(b,iunit)
call free_bmp(b)
deallocate(c)

close(unit=iunit)

end
