program cube2line

use io

implicit none

integer           :: i,j,k,mdv,iunit
real*8            :: sum1, sum2
type(cube)        :: c
character(len=30) :: fi,fo

iunit=7

print*,"name of cube file"
read(*,33)fi
open(unit=iunit,file=fi,status="unknown")
print*,"name of output file"
read(*,33)fo
print*,"multiply by dv? 1 0"
read*,mdv

call read_cube(c,iunit)

open(unit=10,file=fo,status="unknown")

sum2=0.d0
sum1=0.d0
print*,c%q
do i=1,c%nz
 if(mdv.eq.1)then
  sum1=sum(c%rho(1:c%nx,1:c%ny,i))*c%dv
 else
  sum1=sum(c%rho(1:c%nx,1:c%ny,i))/(c%nx*c%ny)
 endif
 sum2=sum2+sum1
 write(10,34)(i-1)*c%dx(3,3),sum1,sum2
enddo

close(unit=34)
close(unit=iunit)

33 format(a)
34 format(3f12.6)

end
