program p

use io
implicit none

real*8              :: c0(3),c1(3)
real, allocatable :: pos(:,:)
integer             :: i,j,iunit,nsteps,startstep,delta_step,num

character(len=4)    :: hdr
character(len=80)   :: dumc1,dumc2
integer             :: dumi,nat
real*8              :: cell(6),sum
real                :: dt

iunit=7
open(unit=iunit,file="traj.dcd",status="unknown",form="unformatted")


read *,nsteps,startstep,delta_step


 read(iunit) hdr,dumi,dumi,dumi,dumi,dumi,dumi, &
             dumi,dumi,dumi,dt,dumi,dumi,dumi ,&
             dumi,dumi,dumi,dumi,dumi,dumi,dumi
 read(iunit) dumi,dumc1,dumc2
 read(iunit) nat


sum=0.d0
num=0
do i=1,startstep-1
 allocate(pos(nat,3))
 read(iunit)cell
 read(iunit)pos(1:nat,1)
 read(iunit)pos(1:nat,2)
 read(iunit)pos(1:nat,3)
 deallocate(pos)
enddo

 allocate(pos(nat,3))
 read(iunit)cell
 read(iunit)pos(1:nat,1)
 read(iunit)pos(1:nat,2)
 read(iunit)pos(1:nat,3)
 c1 = pos(4,1:3)+pos(5,1:3)+pos(7,1:3)+ pos(10,1:3)+pos(11,1:3)+pos(16,1:3)
 c1=c1/6
 c1(3)=0
 deallocate(pos)
do i=startstep,nsteps - delta_step,delta_step
 c0 = c1
 do j=1,delta_step-1
  allocate(pos(nat,3))
  read(iunit)cell
  read(iunit)pos(1:nat,1)
  read(iunit)pos(1:nat,2)
  read(iunit)pos(1:nat,3)
  deallocate(pos)
 enddo
  allocate(pos(nat,3))
  read(iunit)cell
  read(iunit)pos(1:nat,1)
  read(iunit)pos(1:nat,2)
  read(iunit)pos(1:nat,3)
  c1 = pos(4,1:3)+pos(5,1:3)+pos(7,1:3)+ pos(10,1:3)+pos(11,1:3)+pos(16,1:3)
  c1=c1/6
  c1(3)=0
  deallocate(pos)
  num=num+1
  write(6,33)i,i+delta_step,(norm(c1-c0))**2/4*2/delta_step/1000,c0(1:2),c1(1:2)
  sum=sum+(norm(c1-c0))**2/4*2/delta_step/1000
enddo
  write(6,34)sum/num

33 format(2i6,e16.4," c0 ",2f8.2,"    c1 ",2f8.2)
34 format(e16.4)

end


