program p

implicit none
include "fftw3.f"
!ifort  p.f90 -I /opt/intel/mkl/include/fftw -L /opt/intel/mkl/lib/em64t/ -lfftw3xf_intel -lmkl_intel_ilp64 -lmkl_intel_thread -lmkl_core -liomp5 -lpthread

integer      :: i,j,k,l,m,n
real*8       :: r
complex*16,allocatable   ::  arr(:),arro(:),arr2(:)
real*8                   :: val,err,scal
integer*8    ::  plan

read*,l
allocate(arr(l))
allocate(arro(l))
allocate(arr2(l))

arr=dcmplx(0.d0,0.d0)
arro=arr
arr2=arr

do i=1,l
   r=((i-l/2)**2 )
   val=exp(-r) 
   arr(i)=dcmplx(val,0.d0)
!  print*,i,r,val,arr(i)
enddo

write(6,*)arr(l/2)

CALL DFFTW_PLAN_DFT_1D(PLAN, l, arr, arro, FFTW_FORWARD,FFTW_ESTIMATE)

write(6,*)arro(l/2)

CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)
CALL DFFTW_PLAN_DFT_1D(PLAN, l, arro, arr2, FFTW_BACKWARD, FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)
write(6,*)arr2(l/2)


end
