program p

implicit none
include "fftw3.f"
!ifort  p.f90 -I /opt/intel/mkl/include/fftw -L /opt/intel/mkl/lib/em64t/ -lfftw3xf_intel -lmkl_intel_ilp64 -lmkl_intel_thread -lmkl_core -liomp5 -lpthread

integer      :: i,j,k,l,m,n
real*8       :: r
complex*16,allocatable   ::  arr(:,:,:),arro(:,:,:),arr2(:,:,:)
real*8                   :: val,err,scal
integer*8    ::  plan

read*,l,m,n
allocate(arr(l,m,n))
allocate(arro(l,m,n))
allocate(arr2(l,m,n))

arr=dcmplx(0.d0,0.d0)
arro=arr
arr2=arr

do i=1,l
 do j=1,m
  do k=1,n
   r=(i-l/2)**2 +(j-m/2)**2 + (k-n/2)**2
   val=exp(-r) 
   arr(i,j,k)=dcmplx(val,0.d0)
!  print*,i,r,val,arr(i)
   enddo
 enddo
enddo

write(6,*)arr(l/2,m/2,k/2),arr(l/2+1,m/2,n/2)

CALL DFFTW_PLAN_DFT_3D(PLAN, l,m,n, arr, arro, FFTW_FORWARD,FFTW_ESTIMATE)

write(6,*)arro(l/2,m/2,n/2)

CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)
CALL DFFTW_PLAN_DFT_3D(PLAN, l,m,n, arro, arr2, FFTW_BACKWARD, FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)
write(6,*)arr2(l/2,m/2,n/2),arr2(l/2+1,m/2,n/2),arr2(l/2+1,m/2,n/2)/arr(l/2+1,m/2,n/2)
deallocate(arr)
deallocate(arro)
deallocate(arr2)


end
