program stmz

use io
use images


implicit none

type(cube)           :: c,pc
type(geo)            :: g
type(bmp)            :: b
real*8, allocatable  :: rgb(:,:,:)
real*8               :: iso,x,y,z,v(3),zguess,zrange,val(-1:1),val1,val2,f0(-2:2,-2:2,-2:2),f(-2:2,-2:2,-2:2),gf(3)
real*8               :: thez,thez1,thez2,poti,rhoi,thr,t(3),max,position(-1:1,3),p1,p2
real*8               :: f1(-2:2,-2:2,-2:2),tocca(-1:1,3)
real*8, allocatable  :: p(:,:),porig(:,:)
integer              :: vi(3),i,j,k,kmin,kmax,thek,dk,i0,j0,iav,vdum(3),s
integer              :: ii,jj,kk,if,jf,kf,p0(3),ni(3),pii(3),ip,p01(3),p02(3)
integer              :: iunit1,iunit2,itip
character(len=30)    :: fi,fip,fp
logical              :: trovato

fi=""
fp=""
fip=""
print*,"1-no tip-shape file"
read*,itip
print*,"name cube file for  charge"
read(*,31)fi
if(itip.gt.1) then
 print*,"name file for tip geometry"
 read(*,31)fp
endif
print*,"name cube file for potential, XX for none"
read(*,31)fip

thr=0.00008
vdum=0

iunit1=7
if(itip.eq.1) then
call create_geo(g,1)
g%p=0.d0
else
 call read_geo(g,fp,13)
endif
allocate(p(g%n,3))
allocate(porig(g%n,3))
porig=g%p

open(unit=iunit1,file=fi,status="unknown")
 call read_cube(c,iunit1)
close(unit=iunit1)

allocate(rgb(3,c%nx,c%ny))

if(fip(1:2).ne."XX") then
 open(unit=iunit1,file=fip,status="unknown")
  call read_cube(pc,iunit1)
 close(unit=iunit1)
endif


do i=1,c%nx
 do j=1,c%ny
  do k=1,c%nz
   if(c%rho(i,j,k).le.thr)c%rho(i,j,k)=0.d0
  enddo
 enddo
enddo

print*,"will create only STM.dat"
open(unit=8,file="STM.dat",status="unknown")
if(fip(1:2).ne."XX") then
 open(unit=9,file="POT_SUISO.dat",status="unknown")
 open(unit=10,file="E_SUISO.dat",status="unknown")
endif

i0=1
j0=1
vi=1

!do i=1,c%nz,2
!
! vi(3)=i
! call xyz(vi,v,c%dx)
! print*,"z ",v(3)," value ",c%rho(vi(1),vi(2),vi(3))
! 
!enddo

zguess=maxval(c%pos(:,3))+7.55
!print*,"isovalue,zmax,iaverage"
!read*,iso,zguess,iav
print*,"isovalue,ismooth, 0=no averaging"
read*,iso,iav

v(3)=zguess
call ijk(vi,v,c%dx)
kmax=vi(3)
print*,"kmax e nz",kmax,c%nz



do i=1,c%nx
if(mod(i,2).eq.0)print*,float(i)/c%nx *100," % done"
 do j=1,c%ny
  vi(1)=i
  vi(2)=j
  vi(3)=kmax              !! added
  pii(1)=i
  pii(2)=j
  call xyz(vi,t,c%dx)     !! added
  do ip=1,g%n             !! added   traslo punta
   p(ip,1:3)=porig(ip,1:3)+t  !! added
  enddo                   !! added
  
  dk= int(   ( (i-i0)*c%dx(1,3)+(j-j0)*c%dx(2,3) )/c%dx(3,3) )

   do ip=1,g%n
    call ijk(ni,p(ip,1:3),c%dx)
    call pbci(ni,c%nx,c%ny,c%nz)
    if(c%rho(ni(1),ni(2),ni(3)).gt.iso)then
     print*,"error ", ni(1),ni(2),ni(3),dk,c%rho(ni(1),ni(2),ni(3))
     stop
    endif
   enddo

  do k=kmax,5-dk,-1

   do s=-1,1
    pii(3)=k+s
    call xyz(pii,t,c%dx)     !! added
    do ip=1,g%n             !! added   traslo punta
     p(ip,1:3)=porig(ip,1:3)+t  !! added
    enddo
    max=-500
    trovato=.false.
    ip=1
    do while((.not.trovato).and.ip.le.g%n)! ip=1,g%n
!    print *,ip
     call ijk(ni,p(ip,1:3),c%dx)
     call pbci(ni,c%nx,c%ny,c%nz)
  
     val(s)=avg_cube(c,ni,iav) !c%rho(ni(1),ni(2),ni(3))
     if(val(s).gt.max)max=val(s)
     if(val(s).ge.iso)trovato=.true.
     tocca(s,1:3)=p(ip,1:3)
     position(s,1:3)=t
     ip=ip+1
    enddo
    val(s)=max

   enddo    !  s

!  val1=c%rho(i,j,k-1)

!  val2=c%rho(i,j,k+1)

   if(val(0).eq.iso)then
!   thek=k
!   vi(3)=thek
!   call xyz(vi,v,c%dx)
!   thez=v(3) 
!   x=v(1)
!   y=v(2)
!   write(9,33)x,y,pc%rho(i,j,thek)
    call ijk(ni,tocca(0,1:3),c%dx)
    x=position(0,1)
    y=position(0,2)
    thez=position(0,3)

    if(fip(1:2).ne."XX") then
    write(9,33)position(0,1:2),avg_cube(pc,ni,iav)
    call ijk(ni,tocca(0,1:3),c%dx)
    p01=ni
    f=0.d0
    do ii=-iav,iav
     do jj=-iav,iav
       do kk=-iav,iav

       f0=0.d0

         do if=-1,1
          do jf=-1,1
           do kf=-1,1
             p0(1)=p01(1)+ii+if
             p0(2)=p01(2)+jj+jf
             p0(3)=p01(3)+kk+kf
             call pbci(p0,c%nx,c%ny,c%nz)
             f0(if,jf,kf)=pc%rho(p01(1),p01(2),p01(3))
           enddo
          enddo
         enddo

         f=f+f0

       enddo
     enddo
    enddo
    f=f/(2*iav+1)**3
    call grad_point(f,vdum,c%dx,gf)
    write(10,33)x,y,norm(gf)
    endif  !!! there is also potentila

    goto 30

   else if(val(-1).gt.iso.and.val(1).lt.iso) then
    
!   vi(3)=k-1
!   call xyz(vi,v,c%dx)
!   thez1=v(3) 
!   x=v(1)
!   y=v(2)
!   vi(3)=k+1
!   call xyz(vi,v,c%dx)
!   thez2=v(3) 
    x=(position(-1,1)+position(1,1))/2.d0
    y=(position(-1,2)+position(1,2))/2.d0
    thez1=position(-1,3)
    thez2=position(1,3)

    thez = thez1 + (val(-1)-iso)*(thez2-thez1)/(val(-1)-val(1))

    if(fip(1:2).ne."XX") then

     call ijk(ni,tocca(-1,1:3),c%dx)
     p1=avg_cube(pc,ni,iav)
!    r1=avg_cube(c%rho,ni,iav)
     call ijk(ni,tocca(1,1:3),c%dx)
     p2=avg_cube(pc,ni,iav)
!    r2=avg_cube(c%rho,ni,iav)
!!    poti=pc%rho(i,j,k-1)+(thez-thez1)* (pc%rho(i,j,k+1) - pc%rho(i,j,k-1))/(thez2-thez1)
!!    rhoi=c%rho(i,j,k-1)+(thez-thez1)* (c%rho(i,j,k+1) - c%rho(i,j,k-1))/(thez2-thez1)
     poti=p1+(thez-thez1)* (p2 - p1)/(thez2-thez1)
!    rhoi=r1+(thez-thez1)* (r2 - r1)/(thez2-thez1)
     write(9,33)x,y,poti
 
     call ijk(ni,tocca(-1,1:3),c%dx)
     p01=ni
     call ijk(ni,tocca(1,1:3),c%dx)
     p02=ni
     f=0.d0
     do ii=-iav,iav
      do jj=-iav,iav
        do kk=-iav,iav 
 
        f0=0.d0
        f1=0.d0
 
          do if=-1,1
           do jf=-1,1
            do kf=-1,1
              p0(1)=p01(1)+ii+if
              p0(2)=p01(2)+jj+jf
              p0(3)=p01(3)+kk+kf
              call pbci(p0,c%nx,c%ny,c%nz)
              f0(if,jf,kf)=pc%rho(p01(1),p01(2),p01(3))
              p0(1)=p02(1)+ii+if
              p0(2)=p02(2)+jj+jf
              p0(3)=p02(3)+kk+kf
              call pbci(p0,c%nx,c%ny,c%nz)
              f1(if,jf,kf)=pc%rho(p02(1),p02(2),p02(3))
            enddo
           enddo
          enddo
 
          f=f+(f0+f1)/2 
 
        enddo
      enddo
     enddo
     f=f/(2*iav+1)**3
     call grad_point(f,vdum,c%dx,gf)
     write(10,33)x,y,norm(gf)

    endif !! also potential
    
    goto 30

   endif

  enddo

  print*,"non trovato,i,j assume k=1",i,j,kmax,dk
    thek=1
    vi(3)=thek
    call xyz(vi,v,c%dx)
    thez=v(3)
    x=v(1)
    y=v(2)
    write(9,33)x,y,pc%rho(i,j,thek)
    goto 30

30 continue

  
  write(8,33)x,y,thez
  rgb(1,i,j)=x
  rgb(2,i,j)=y
  rgb(3,i,j)=thez

 enddo
enddo

call real2bmp(rgb,b,800)
open(unit=19,file="STM.bmp",status="unknown")
 call write_bmp(b,19)
close(unit=19)

31 format(a)
33 format("{",f12.6,",",f12.6,",",f12.6,"},")
34 format(4f12.6)

close(unit=8)
close(unit=9)
close(unit=10)
call destroy_geo(g)
call free_cube(c)
call free_bmp(b)
if(fip(1:2).ne."XX")call free_cube(pc)
deallocate(rgb)

end
