 program main
 include "mpif.h"
 integer :: n, myid, numprocs, i,j, ierr,iunit,ncicle,nmax
 real*8, allocatable  :: a(:)

 call MPI_INIT(ierr)
 call MPI_COMM_RANK(MPI_COMM_WORLD, myid, ierr)
 call MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)

 
 if(myid.eq.0)read(5,*)ncicle,nmax
 call  mpi_bcast(ncicle, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
 call  mpi_bcast(nmax, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
 call mpi_barrier(MPI_COMM_WORLD,ierr)
 write(6,*) myid,ncicle,nmax
 call mpi_barrier(MPI_COMM_WORLD,ierr)
 
   iunit=1000+myid
   allocate(a(1:nmax))
   a=0.d0
   open(unit=iunit,form="unformatted")
   write(iunit)a
   close(unit=iunit)
   deallocate(a)
   do j=1,4
   
    if(myid.eq.0.)write(6,*) j
    allocate(a(1:nmax))
    open(unit=iunit,form="unformatted")
    read(iunit)a
    close(unit=iunit)
   
    do i=1,nmax
     a(i)=a(i)+sqrt(i*1.d0/(myid+1+a(i)))
    enddo
    open(unit=iunit,form="unformatted")
    write(iunit)a
    close(unit=iunit)
    if(myid.eq.0.or.myid.eq.numprocs-1)write(6,*) myid,a(1),a(nmax)
    deallocate(a)
   enddo

end
