program stmz

use cubefile
use io


implicit none

type(cube)         :: c,p
real*8             :: iso,x,y,z,v(3),zguess,zrange,val,val1,val2,f0(-2:2,-2:2,-2:2),f(-2:2,-2:2,-2:2),gf(3)
real*8             :: thez,thez1,thez2,s(2),poti,rhoi,thr
integer            :: vi(3),i,j,k,kmin,kmax,thek,dk,i0,j0,iav,vdum(3)
integer            :: ii,jj,kk,if,jf,kf,p0(3),iunit
character(len=30)  :: fi,fip

print*,"nome file charge"
read(*,31)fi
print*,"nome file pot"
read(*,31)fip

thr=0.00008
vdum=0

iunit=7
open(unit=iunit,file=fi,status="unknown")
call read_cube(c,iunit)
close(unit=iunit)
open(unit=iunit,file=fip,status="unknown")
call read_cube(p,iunit)
close(unit=iunit)

do i=1,c%nx
 do j=1,c%ny
  do k=1,c%nz
   if(c%rho(i,j,k).le.thr)c%rho(i,j,k)=0.d0
  enddo
 enddo
enddo

open(unit=8,file="STM.dat",status="unknown")
open(unit=9,file="POT_SUISO.dat",status="unknown")
open(unit=10,file="E_SUISO.dat",status="unknown")

!call ijk(vi,c%pos(1,1:3),c%dx)
!i0=vi(1)
!j0=vi(2)
i0=1
j0=1
vi=1

do i=1,c%nz,2

 vi(3)=i
 call xyz(vi,v,c%dx)
 print*,"z ",v(3)," value ",c%rho(vi(1),vi(2),vi(3))
 
enddo

print*,"isovalue,zmax,sx,sy,iaverage"
read*,iso,zguess,s,iav

v(3)=zguess
call ijk(vi,v,c%dx)
kmax=vi(3)
print*,"kmax e nz",kmax,c%nz



do i=1,c%nx
 do j=1,c%ny
! thek=kmax
  vi(1)=i
  vi(2)=j
! dk= int(   ( (i0-i)*c%dx(1,3)+(j0-j)*c%dx(2,3) )/c%dx(3,3) )
  dk= int(   ( (i-i0)*c%dx(1,3)+(j-j0)*c%dx(2,3) )/c%dx(3,3) )
! print*,kmax,dk
! vi(3)=thek
! call xyz(vi,v,c%dx)
! thez=v(3) 
! if(c%rho(i,j,kmin).eq.iso)goto 30 
! if(c%rho(i,j,kmin).lt.iso.and.c%rho(i,j,kmin).lt.c%rho(i,j,kmin)) then
!  goto 30
! endif
! do k=kmax+dk,5-dk,-1
   if(c%rho(i,j,kmax).gt.iso)then
    print*,"orrore orrore"
    stop
   endif
  do k=kmax,5-dk,-1
   val=c%rho(i,j,k)
   val1=c%rho(i,j,k-1)
   val2=c%rho(i,j,k+1)
   if(val.eq.iso)then
    thek=k
    vi(3)=thek
    call xyz(vi,v,c%dx)
    thez=v(3) 
    x=v(1)
    y=v(2)
    write(9,33)x,y,p%rho(i,j,thek)
    goto 30
   else if(val1.gt.iso.and.val2.lt.iso) then
    
    vi(3)=k-1
    call xyz(vi,v,c%dx)
    thez1=v(3) 
    x=v(1)
    y=v(2)
    vi(3)=k+1
    call xyz(vi,v,c%dx)
    thez2=v(3) 

    thez = thez1 + (val1-iso)*(thez2-thez1)/(val1-val2)
    poti=p%rho(i,j,k-1)+(thez-thez1)* (p%rho(i,j,k+1) - p%rho(i,j,k-1))/(thez2-thez1)
    rhoi=c%rho(i,j,k-1)+(thez-thez1)* (c%rho(i,j,k+1) - c%rho(i,j,k-1))/(thez2-thez1)
    write(9,33)x,y,poti

    f=0.d0
    do ii=-iav,iav
     do jj=-iav,iav
       do kk=-iav,iav 

       f0=0.d0

         do if=-1,1
          do jf=-1,1
           do kf=-1,1
             p0(1)=i+ii+if
             p0(2)=j+jj+jf
             p0(3)=k+kk+kf
             call pbci(p0,c%nx,c%ny,c%nz)
             f0(if,jf,kf)=p%rho(p0(1),p0(2),p0(3))
           enddo
          enddo
         enddo

         f=f+f0 

       enddo
     enddo
    enddo
    f=f/(2*iav+1)**3
    call grad_point(f,vdum,c%dx,gf)
    write(10,33)x,y,norm(gf)
    
    goto 30

   endif

  enddo

! vi(3)=kmax
! call xyz(vi,v,c%dx)
! thez=v(3) 
  print*,"non trovato,i,j assume k=1",i,j,kmax,dk
    thek=1
    vi(3)=thek
    call xyz(vi,v,c%dx)
    thez=v(3)
    x=v(1)
    y=v(2)
    write(9,33)x,y,p%rho(i,j,thek)
    goto 30
! do k=kmax,5-dk,-1
!   vi(3)=k
!   call xyz(vi,v,c%dx)
!   print*,"z ",v(3)," value ",c%rho(vi(1),vi(2),vi(3))
! enddo
! stop

30 continue

  
  write(8,33)x,y,thez
! write(9,34)x,y,p(hh

 enddo
enddo

31 format(a)
33 format("{",f12.6,",",f12.6,",",f12.6,"},")
34 format(4f12.6)

close(unit=8)
close(unit=9)
close(unit=10)

end
