program p


use io

implicit none

integer             :: i,iunit
character(len=30)   :: fi,fo
type(geo)           :: g
real*8              :: posa(3,3),posc(3,3),a0,a1
real*8              :: t(3,3),p0(3,3),p1(3,3),basis0(3,3),basis1(3,3)

fi="pos.xyz"
fo="po1.xyz"
iunit=7
open(unit=iunit,file=fi,status="unknown")

call read_geo(g,fi,iunit)
close(unit=iunit)
read*,a0,a1
basis0=0.d0
basis1=0.d0
basis0(1,1)=a0/sqrt(2.d0) * 6.d0
basis0(2,1)=-basis0(1,1)/2.d0
basis0(2,2)=basis0(1,1)*dsqrt(3.d0)/2.d0
basis0(3,3)=37
basis1(1,1)=a1/sqrt(2.d0) * 6.d0
basis1(2,1)=-basis1(1,1)/2.d0
basis1(2,2)=basis1(1,1)*dsqrt(3.d0)/2.d0
basis1(3,3)=37

p0(1,1)=sum(g%p(1:33,1))/33.d0
p0(1,2)=sum(g%p(1:33,2))/33.d0
p0(1,3)=sum(g%p(1:33,3))/33.d0


p0(2,1)=sum(g%p(34:66,1))/33.d0
p0(2,2)=sum(g%p(34:66,2))/33.d0
p0(2,3)=sum(g%p(34:66,3))/33.d0

p0(3,1)=sum(g%p(67:99,1))/33.d0
p0(3,2)=sum(g%p(67:99,2))/33.d0
p0(3,3)=sum(g%p(67:99,3))/33.d0

call cart2aff(p0,posa,basis0)
call aff2cart(posa,p1,basis1)

t=p1-p0

do i=1,33
 g%p(i,1:3)=g%p(i,1:3)  +t(1,1:3)
enddo
do i=34,66
 g%p(i,1:3)=g%p(i,1:3)  +t(2,1:3)
enddo
do i=67,99
 g%p(i,1:3)=g%p(i,1:3)  +t(3,1:3)
enddo

open(unit=iunit,file="h0",status="unknown")
write(7,*)"  &CELL"
write(7,33)basis1(1,1:3)
write(7,34)basis1(2,1:3)
write(7,35)basis1(3,1:3)
write(7,*)" &END"
write(7,*)" &COORD"
close(unit=iunit)
open(unit=iunit,file=fo,status="unknown")
call write_xyz(g,iunit)
close(unit=iunit)

33 format("  A [angstrom] ",3f12.6)
34 format("  B [angstrom] ",3f12.6)
35 format("  C [angstrom] ",3f12.6)

end
