program omega

use io

implicit none

type(geo)             :: g,g1
real*8, allocatable   :: v(:,:)
real*8                :: I(3,3),l(3),w(3),xcm(3),vcm(3),vi(3)
integer               :: k,i1,i2,i3
character(len=20)     :: fi,fv,fvo

i1=7
i2=8
i3=9
fi=""
fv=""
fvo=""
print*,"coordinate file in  xyz format or .restart file"
read(*,33)fi
open(unit=7,file=fi,status="unknown")
if(thereis(fi,"restart"))then
 call read_cp2k_restart(g,g1,i1)
else
 print*,"velocity file in xyz format with vel in a.u. (bohr/0.025fs)"
 read(*,33)fv
 open(unit=8,file=fv,status="unknown")
 call read_xyz(g,7)
 call read_xyz(g1,8)
endif

print*,"output file for velocities "
read(*,33)fvo

call init_periodic_table()

open(unit=9,file=fvo,status="unknown")


g%p=g%p/0.529177d0

xcm=0
I=0
w=0
allocate(v(g%n,3))
call cm(g,xcm)
call cm(g1,vcm)

do k=1,g1%n
 g1%p(k,1:3)=g1%p(k,1:3)-vcm
 g%p(k,1:3)=g%p(k,1:3)-xcm
enddo

v=g1%p

call inertia(g,v,I)
print*,I(1,1:3)
print*,I(2,1:3)
print*,I(3,1:3)
call angular(g,v,I,L,w)
print*,"v cm and w ",vcm,w

do k=1,g1%n
 vi=g%p(k,1:3)
 call vecprod(vi,w)   !!! SIGN trick....!!
 g1%p(k,1:3)=g1%p(k,1:3)+vi
enddo

call write_xyz(g1,9)

close(unit=7)
close(unit=8)
close(unit=9)

deallocate(v)

33 format(a)


end
