program cube2xyzrho

use io
implicit none

type(cube)                      :: c
character(len=40)               :: fi,fo
integer                         :: i1,i,j,k,vi(3)
real*8                          :: v(3)


print*,"input cube file"
read(*,33)fi
print*,"output file"
read(*,33)fo

i1=7
open(unit=i1,file=fi,status="unknown")
 call read_cube(c,i1)
close(unit=i1)
open(unit=i1,file=fo,status="unknown")
 do i=1,c%nx
  do j=1,c%ny
   do k=1,c%nz
    vi(1)=i
    vi(2)=j
    vi(3)=k
    call xyz(vi,v,c%dx)
    write(i1,34)v*0.529177d0,c%rho(i,j,k)/((0.529177d0)**3)
   enddo
  enddo
 enddo
close(unit=i1)

33 format(a)
34 format(3f12.6,f16.10)

end
