program diffcube

use io
use cubefile

implicit none


type(cube)          :: c1,c2
real*8, allocatable :: rho(:,:,:)
integer             :: i1,signum
character(LEN=30)   :: f1,f2,f3

print*,"signum: 1 or -1"
read*, signum
print*,"name file cube 1  will do 1 + sign * 2"
read(*,31)f1
print*,"name file cube 2 "
read(*,31)f2
print*,"name file out"
read(*,31)f3

i1=7
open(unit=i1,file=f2,status="unknown")
 call read_cube(c2,i1)
close(unit=i1)
open(unit=i1,file=f1,status="unknown")
 call read_cube(c1,i1)
close(unit=i1)
allocate(rho(c1%nx,c2%ny,c2%nz))
rho=c1%rho+signum*c2%rho
c1%rho=rho

open(unit=i1,file=f3,status="unknown")
 call write_cube(c1,i1)
close(unit=i1)

call free_cube(c1)
call free_cube(c2)
deallocate(rho)

31 format(a)

end
