program t

use tricks
use operations

implicit none

integer                          :: i,ii,j,k,dum,natoms,nsteps,nintervals
integer                          :: dum1,dum2,dum3,def_int,fc,count
integer, allocatable             :: intervalss(:,:)
real*8, allocatable              :: p(:,:,:)

real*8,allocatable               :: allpos(:,:,:)
character(len=2),allocatable     :: nomi(:)
character(len=120)                :: line,fi,fo
character                        :: dumr

print*, "file in"
read(*,32)fi
print*, "file out"
read(*,32)fo

open(unit=7,file=fi,status="unknown")
read(7,*)natoms
close(unit=7)
open(unit=7,file=fi,status="unknown")
open(unit=8,file=fo,status="unknown")

print*,"num steps"
read*,nsteps
print*,"num non default intervals , default value of images betweeen non specified intervals  steps"
read*,nintervals,def_int

count=0
allocate(allpos(nsteps,natoms,3)) 
allocate(nomi(natoms))
allocate(intervalss(nsteps-1,3))
do i=1,nsteps,-1
 intervalss(i,1)=i
 intervalss(i,2)=i+1
 intervalss(i,3)=def_int
enddo
do i=1,nintervals
 print*, " step i step f and intermediate points for interval ",i
 read*,dum1,dum2,dum3
 do j=dum1,dum2-1
  intervalss(j,1)=j
  intervalss(j,2)=j+1
  intervalss(j,3)=dum3
 enddo
enddo


do i=1,nsteps
 read(7,*)dum
 read(7,*)dumr
 do j=1,natoms
  read(7,32)line
  fc=first_char(line)
  read(line(fc:fc+1),33)nomi(j)
  read(line(fc+2:120),*)allpos(i,j,1:3)
 enddo
enddo
close(unit=7)


do i=1,nsteps-1
 if(intervalss(i,3).gt.0) then
  allocate(p(intervalss(i,3)+2,natoms,3))
  p=0
   p(1,1:natoms,1:3)=allpos(intervalss(i,1),1:natoms,1:3)
   p(intervalss(i,3)+2,1:natoms,1:3)=allpos(intervalss(i,2),1:natoms,1:3)
   call interpola(p)

    count=count+1
    write(8,*)natoms
    write(8,*)"  original image  ",i," actual ",count
    do k=1,natoms
     write(8,34)nomi(k)(1:2),allpos(i,k,1:3)
    enddo

   do ii=2,intervalss(i,3) +1
    count=count+1
    write(8,*)natoms
    write(8,*)"  interpolato  ",intervalss(i,1),intervalss(i,2),ii-1,count
    do k=1,natoms
     write(8,34)nomi(k)(1:4),p(ii,k,1:3)
    enddo
   enddo


  deallocate(p)

    count=count+1
    if(count.lt.nsteps) then
     write(8,*)natoms
     write(8,*)"  original image  ",i+1," actual ",count
     do k=1,natoms
      write(8,34)nomi(k)(1:2),allpos(i+1,k,1:3)
     enddo
    endif

 else
    write(8,*)natoms
    write(8,*)"  original image  ",i," actual ",count
    do k=1,natoms
     write(8,34)nomi(k)(1:2),allpos(i,k,1:3)
    enddo
 endif

enddo

write(8,*)natoms
write(8,*)"  last step  "
do k=1,natoms     ! LAST FRAME
 write(8,34)nomi(k),allpos(nsteps,k,1:3)
enddo


close(unit=8)
32 format(a)
33 format(a)
34 format(a2,3f12.6)

end
