program squarecube

use io
use cubefile

implicit none


type(cube)          :: c1
real*8, allocatable :: rho(:,:,:)
integer             :: i1
character(LEN=30)   :: f1,f2,f3

print*,"name file cube "
read(*,31)f1
print*,"name file out"
read(*,31)f3

i1=7
open(unit=i1,file=f1,status="unknown")
 call read_cube(c1,i1)
close(unit=i1)
allocate(rho(c1%nx,c1%ny,c1%nz))
rho=c1%rho*c1%rho
c1%rho=rho

open(unit=i1,file=f3,status="unknown")
 call write_cube(c1,i1)
close(unit=i1)

call free_cube(c1)
deallocate(rho)

31 format(a)

end
