program stmz

use io
use images


implicit none

type(cube)           :: c,pc
!type(geo)            :: g
type(bmp)            :: b
real*8, allocatable  :: rgb2(:,:),rgb3(:,:),rgb4(:,:)
real*8               :: iso,x,y,z,v(3),v0(3),zguess,zrange,val(0:2),f(-2:2,-2:2,-2:2),gf(3)
real*8               :: thez,thez1,thez2,poti,rhoi,thr,t(3),max,p1(2),p2
real*8               :: r,dr,vol,zs(0:2)
real*8               :: ld(3),lu(3),lr(3),ll(3),ud(3),uu(3),ur(3),ul(3),basis(3,3),u0(3),t1(3)
real*8               :: potval(0:6),macrodx(3,3),d1,bb(3),valo
real*8               :: dl(3),linelength,p0(2),bottom,top,box(4),vadd(2)
real*8               :: xadd,yadd,vertex(4,2),fac,zmin,zmax
real*8               :: coe(3),ppar(3,2),dxrgb
real*8, allocatable  :: p(:,:),porig(:,:)
integer, allocatable :: lista(:,:),gridpoints(:,:)
integer              :: vi(3),i,j,k,kmin,kmax,thek,dk,i0,j0,iav,vdum(3),s,km0,km1
integer              :: ii,jj,kk,if,jf,kf,ni(3),ip,id(1)
integer              :: iunit,iunit1,iunit2,itip,ndx,bigs,increments(0:6,3)
integer              :: bimin,bimax,bjmin,bjmax,bkmin,bkmax,num(0:6),dwz
integer              :: npoints,bounds(8,3),vsmall(3),vh(3)
integer              :: maxpoints,quantipoints,thevguess(3),iq,iz,theelement
integer              :: id1,id2,count,vid1(3),vid2(3),igrids,nx,ny,nxnew,addpoints
integer              :: n1,n2,nmax,nmax1,kold,nxb,nyb,verso,nd
character(len=30)    :: fi,fip,fp,fii,fo,fo1,fo2,fc
character(len=11)    :: fmti
logical              :: stmline,lbottom,from_bottom,truechd

fmti="(    f10.4)"
lbottom=.false.
from_bottom=.false.
verso=1
addpoints=0
bottom=5000
top=-5000
stmline=.false.
fi=""
fp=""
fip=""
print*,"name cube file for  charge"
read(*,31)fi
print *,"downsize factor : 1 or 2 or .."
read*,dwz

fii=fi
fo=fi
fo1=fi
i=strlen(fii)
fii(i-3:i)="info"
fo1(i-3:i)="igor"
fo(i-3:i-1)="bmp"
fo(i:i)=""
fo2=fo
fo2(i-3:i-1)="dat"
open(unit=12,file=fii,status="unknown")

print*,"radius in A od the tip"
read(*,*)r
write(12,*)" r ",r
r=r/0.529177d0
print*,"from botom .true. or .false.?"
read*,from_bottom
print*,"name cube file for potential, XX for none"
read(*,31)fip
print*,"n dx for the derivatives e.g. 1 or 2 or 3 ?"
read*,ndx
print*,"id1 id2 for line STM, 0 0 for whole surface"
read*,id1,id2
print*,"nx boxes, ny boxes"
read*,nxb,nyb


if(from_bottom)verso=-1
increments=0
increments(1,3)=ndx*verso
increments(2,3)=-ndx*verso
increments(3,1)=-ndx
increments(4,1)=ndx
increments(5,2)=ndx
increments(6,2)=-ndx

vdum=0
iunit=13
iunit1=7

open(unit=iunit1,file=fi,status="unknown")
 call read_cube(c,iunit1)
close(unit=iunit1)


n1=c%nx/dwz
if(mod(c%nx,dwz).gt.0)n1=n1+1
n2=c%ny/dwz
if(mod(c%ny,dwz).gt.0)n2=n2+1


!nmax1=c%nx*c%ny+2*c%nx*c%ny*(nxb*nyb-1)
!nmax=c%nx*c%ny
nmax1=n1*n2+2*n1*n2*(nxb*nyb-1)
nmax=n1*n2

basis(1,1:3)=c%dx(1,1:3)*c%nx
basis(2,1:3)=c%dx(2,1:3)*c%ny
basis(3,1:3)=c%dx(3,1:3)*c%nz
vertex=0.d0
vertex(2,1:2)=basis(1,1:2)
vertex(3,1:2)=basis(2,1:2)
vertex(4,1:2)=basis(1,1:2)+basis(2,1:2)
box(1)=minval(vertex(1:4,1))*nxb
box(2)=maxval(vertex(1:4,1))*nxb
box(3)=minval(vertex(1:4,2))*nyb
box(4)=maxval(vertex(1:4,2))*nyb
print*,box

dl=0.d0
igrids=1
count=0
if(id1.gt.0.and.id2.gt.0)stmline=.true.
if(.not.stmline)then
 igrids=nmax1
 allocate(gridpoints(igrids,2))
 do i=1,c%nx,dwz
  do j=1,c%ny,dwz
   count=count+1
   gridpoints(count,1)=i
   gridpoints(count,2)=j
  enddo
 enddo
 igrids=count
else
 v0=c%pos(id1,1:3)
 p0=c%pos(id2,1:2)
 p1=c%pos(id1,1:2)
 call ijk(vid1,c%pos(id1,1:3),c%dx)
 call ijk(vid2,c%pos(id2,1:3),c%dx)
 linelength=norm(p1-p0)
 dl(1:2)=(p1-p0)/linelength*0.05d0
 count=int(linelength/0.05d0)+1
 allocate(gridpoints(count,2))
 gridpoints(igrids,1)=vid1(1)
 gridpoints(igrids,2)=vid1(2)
 do i=2,count
  v=v0+i*dl
  call ijk(vi,v,c%dx)
  if((vi(1).ne.gridpoints(i-1,1)).and.(vi(2).ne.gridpoints(i-1,2))) then
   igrids=igrids+1
   gridpoints(igrids,1)=vi(1)
   gridpoints(igrids,2)=vi(2)
  endif
 enddo

endif
print*,igrids,gridpoints(1,1:2)
if(.not.stmline)allocate(rgb2(2*nmax1,3))

if(fip(1:2).ne."XX") then
 open(unit=iunit1,file=fip,status="unknown")
  call read_cube(pc,iunit1)
 close(unit=iunit1)
endif

dr=max( norm(c%dx(1,1:3)),norm(c%dx(2,1:3)) )
dr=max(dr, norm(c%dx(3,1:3)))*2.1d0
write(6,302)"give me dr in A , suggested and min  value: ",dr*0.529177d0,dr/2.1*0.529177d0
read*,dr
write(12,*)" dr ",dr
dr=dr/0.529177d0
!dr=(norm(c%dx(1,1:3)) + norm(c%dx(2,1:3)) + norm(c%dx(3,1:3)) )/3.d0*2.d0
vol=2.d0/3.d0*4.d0*datan(1.d0)*(r**3 - (r-dr)**3 )
if(r.lt.0.01)vol=1.d0
print*,"volume and thickness of the shell in A:   ",vol*(0.529177**3),dr*0.529177
maxpoints=3*vol/c%dv
allocate(lista(maxpoints,3))
macrodx=ndx*c%dx

ld=0.d0
ld(2)=-r
lu=0.d0
lu(2)=r
lr=0.d0
lr(1)=r
ll=0.d0
ll(1)=-r
ud=0.d0
ud(2)=-r
ud(3)=r
uu=0.d0
uu(3)=r
uu(2)=r
ur=0.d0
ur(3)=r
ur(1)=r
ul=0
ul(1)=-r
ul(3)=r
u0=0
u0(3)=r

!print*,"zmax atom:",maxval(c%pos(1:c%natoms,3)), "zmin and zmax?"
!read*,zmin,zmax
!v=0
!v(3)=zmax
!call ijk(vh,v,c%dx)
!km1=vh(3)
!v(3)=zmin
!call ijk(vh,v,c%dx)
!km0=vh(3)
thr=1.d0
do i=1,c%nx
 do j=1,c%ny
  do k=1,c%nz
   valo=c%rho(i,j,k)
   if(valo.le.thr.and.valo.gt.0.d0)thr=valo
  enddo
 enddo
enddo
if(thr.lt.1.0d-29) thr=1.0d-29
!thr=thr*1.01d0
print*, "set threshold to : " ,thr
do i=1,c%nx
 do j=1,c%ny
! do k=km0,km1
  do k=1,c%nz
   valo=c%rho(i,j,k)
   if(valo.le.thr) c%rho(i,j,k)=0.d0
  enddo
 enddo
enddo

!c%rho(1:c%nx,1:c%ny,1:km0)=0.d0
!c%rho(1:c%nx,1:c%ny,km1:c%nz)=0.d0

open(unit=8,file=fo2,status="unknown")
if(fip(1:2).ne."XX") then
 open(unit=9,file="POT_SUISO.dat",status="unknown")
 open(unit=10,file="E_SUISO.dat",status="unknown")
endif

i0=1
j0=1
vi=1

!!!!!!!!!!!!!!!!!!!!!!GUESSES SECTION!!!!!!!!!!!!!!!!!!!!!!!
quantipoints=0
if(from_bottom) then
zguess=minval(c%pos(:,3))-7.55
id=minloc(c%pos(:,3))
else
zguess=maxval(c%pos(:,3))  +7.55
id=maxloc(c%pos(:,3))
endif
t=c%pos(id(1),1:3) !-3.782
print*, "id of higher/lower z atom: ",id(1), t(3)
t(3)=t(3)+verso*0.5d0/0.529177d0
call ijk(thevguess,t,c%dx)
call xyz(thevguess,t,c%dx)
print*,t
!print*,"thevguess: ",thevguess

open(unit=13,file="tipcontrol.xyz",status="unknown")
do iz=0,5
 t(3)=t(3)+verso*dfloat(iz)/0.529177d0
 num=0
 val=0.d0
 potval=0.d0
    bb=t+ld
    call ijk(bounds(1,1:3),bb,c%dx)
    bb=t+lu
    call ijk(bounds(2,1:3),bb,c%dx)
    bb=t+lr
    call ijk(bounds(3,1:3),bb,c%dx)
    bb=t+ll
    call ijk(bounds(4,1:3),bb,c%dx)
    bb=t+ud
    call ijk(bounds(5,1:3),bb,c%dx)
    bb=t+uu
    call ijk(bounds(6,1:3),bb,c%dx)
    bb=t+ur
    call ijk(bounds(7,1:3),bb,c%dx)
    bb=t+ul
    call ijk(bounds(8,1:3),bb,c%dx)
    bimin=minval(bounds(1:8,1))-1
    bimax=maxval(bounds(1:8,1))+1
    bjmin=minval(bounds(1:8,2))-1
    bjmax=maxval(bounds(1:8,2))+1
    bkmin=minval(bounds(1:8,3))-1
    bkmax=maxval(bounds(1:8,3))+1
    !!!! end xmin xmax.....
!   print*,c%nx,c%ny,c%nz
!   print*,bimin,bimax,bjmin,bjmax,bkmin,bkmax
    if(r.lt.0.01) then
     bimin=bounds(1,1)
     bimax=bounds(1,1)
     bjmin=bounds(1,2)
     bjmax=bounds(1,2)
     bkmin=bounds(1,3)
     bkmax=bounds(1,3)
    endif

    if(iz.eq.0)then
     write(13,39)"Cu ",(t+u0)*0.529177,0, 0, 0, 0.d0
    endif
    do ii=bimin,bimax        !!!! define the set of mesh points inside the spherical shell
     do jj=bjmin,bjmax
      do kk=bkmin,bkmax
        vsmall(1)=ii
        vsmall(2)=jj
        vsmall(3)=kk
        call xyz(vsmall,t1,c%dx)
        d1=distanza(t1,t+u0,basis)
!       if(d1.le.r+dr.and.d1.ge.r-2.d0*dr) then   !SAFER
        if((d1.le.r+1.d-8.and.d1.ge.r-dr-1.d-8.and.(t1(3).le.t(3)+u0(3))).or.r.lt.0.01d0) then
         call pbci(vsmall,c%nx,c%ny,c%nz)
         if(iz.eq.0)then
          write(13,39)"Ti ",t1(1:3)*0.529177,vsmall(1),vsmall(2),vsmall(3),c%rho(vsmall(1),vsmall(2),vsmall(3))
          quantipoints=quantipoints+1
          if(quantipoints.eq.maxpoints) then
           print*, "too many"
           stop
          endif 
          lista(quantipoints,1)=ii
          lista(quantipoints,2)=jj
          lista(quantipoints,3)=kk
         endif
!         if(d1.le.r.and.d1.ge.r-dr) then           !SAFER
           val(0)=val(0)+c%rho(vsmall(1),vsmall(2),vsmall(3))
           num(0)=num(0)+1
        else
          if(iz.eq.0) write(13,39)"O ",t1(1:3)*0.529177,0,0,0,d1*0.529177
        endif                            
!       endif                                         !SAFER
      enddo
     enddo
    enddo

    val(0)=val(0)/num(0)*vol
    if(iz.eq.0) print*,"points in the sphere and val ", num(0),val(0)/vol
    write(6,38),0.5+iz, val(0),val(0)/vol
enddo
38 format(f8.2," Angstrom above max z q and rho are : ",2e16.8)
39 format(a3,3f12.6,3i4,e16.8)
close(unit=13)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

print*,"isovalue? "
read*,iso
write(12,*)"dwz and iso ",dwz,iso
print*,".true. for charge density, .false. for charge "
read*,truechd
write(12,*)"truechd ", truechd

if(truechd)vol=1.d0

v(1:2)=c%pos(id(1),1:2)
print*,"zguess suggested: ",zguess
print*,"max z: " , c%nz*c%dx(3,3)
print*," give me zguess"
read*,zguess
v(3)=zguess
call ijk(vi,v,c%dx)
kmax=vi(3)
print*,"kmax e nz",kmax,c%nz,v(3)



kold=kmax-5*verso
do i=1,igrids
  lbottom=.false.
  if(mod(i,igrids/50).eq.0)write(6,300)nint(1.d0*i/igrids*100)," % done"
  vi(1)=gridpoints(i,1)
  vi(2)=gridpoints(i,2)


  do while(.not.lbottom)
   kold=kold+5*verso
   vi(3)=kold


   
   npoints=2
   if(fip(1:2).ne."XX") npoints=6
   num=0
   val=0.d0
   potval=0.d0

   do s=0,npoints

    vh=vi+increments(s,1:3)
    call xyz(vh,t,c%dx)     !! added
    if(s.eq.0) then
     x=t(1)
     y=t(2)
    endif

   do  iq=1,quantipoints    !!! here compute the charge density sum from all the points in the spherical shell

        vsmall(1)=lista(iq,1) - thevguess(1) + vh(1)
        vsmall(2)=lista(iq,2) - thevguess(2) + vh(2)
        vsmall(3)=lista(iq,3) - thevguess(3) + vh(3)
        call xyz(vsmall,t1,c%dx)
!       d1=distanza(t1,t+u0,basis)    !SAFER
!       if(d1.le.r.and.d1.ge.r-dr) then  !SAFER
         call pbci(vsmall,c%nx,c%ny,c%nz)
         if(s.le.2) then
          val(s)=val(s)+c%rho(vsmall(1),vsmall(2),vsmall(3))
         endif
         num(s)=num(s)+1
         if(fip(1:2).ne."XX") then
          potval(s)=potval(s)+pc%rho(vsmall(1),vsmall(2),vsmall(3))
         endif
!       endif  !SAFER


   enddo

   if(s.le.2) then
    val(s)=val(s)/num(s)*vol
    zs(s)=t(3)+verso*u0(3)
   endif
   if(fip(1:2).ne."XX") then
    potval(s)=potval(s)/num(s)
   endif

   enddo    !  s

   if(val(1).gt.iso) then
!   print*,"too close restart from kmax",i,val(1)
    kold=kmax-5*verso
    goto 311
   endif
   if(val(0).eq.iso)then

    thez=zs(0)
    if(fip(1:2).ne."XX") then
    write(9,33)t+verso*u0,potval(0)
    f=0.d0

    f(0,0,1) =potval(1)
    f(0,0,-1)=potval(2)
    f(-1,0,0)=potval(3)
    f(1,0,0) =potval(4)
    f(0,1,0) =potval(5)
    f(0,-1,0)=potval(6)

    call grad_point(f,vdum,macrodx,gf)
    write(10,33)x,y,norm(gf)
    endif  !!! there is also potentila

    goto 30

   else if(val(2).gt.iso.and.val(1).lt.iso) then
    
    thez1=zs(2)
    thez2=zs(1)
    ppar(1,1)= thez1
    ppar(2,1)= zs(0)
    ppar(3,1)= thez2
    ppar(1,2)= val(2)
    ppar(2,2)= val(0)
    ppar(3,2)= val(1)

!   thez = thez1 + (val(2)-iso)*(thez2-thez1)/(val(2)-val(1))  !!!CONTROLLARE!!!!!!!!
    call par3p(ppar,coe)
    thez=xparab(iso,zs(0),coe)

    if(fip(1:2).ne."XX") then

    f=0.d0
    f(0,0,1) =potval(1)
    f(0,0,-1)=potval(2)
    f(-1,0,0)=potval(3)
    f(1,0,0) =potval(4)
    f(0,1,0) =potval(5)
    f(0,-1,0)=potval(6)
     call grad_point(f,vdum,macrodx,gf)
     write(10,33)x,y,norm(gf)

    endif !! also potential
    
    goto 30

   endif

  kold=kold-6*verso
  if(from_bottom)then
   if(kold.ge.c%nz-10)lbottom=.true.
  else
   if(kold.le.10)lbottom=.true.
  endif
311 continue
  enddo

  print*,"non trovato,i,j assume k=1",vi(1),vi(2),kmax,dk
    thek=1
    vi(3)=thek
    call xyz(vi,v,c%dx)
    thez=v(3)
    x=v(1)
    y=v(2)
    if(fip(1:2).ne."XX") then
       write(9,33)x,y,potval(0)+(potval(1)-potval(2))*(thez-thez1)/(thez2-thez1)
    endif

30 continue

  
! print*,"TROVATO: ",x,y,thez
  if(.not.stmline) then
   write(8,33)x,y,thez,val(1:2)
!  theelement=(i-1)*c%ny+j
   rgb2(i,1)=x
   rgb2(i,2)=y
   rgb2(i,3)=thez
   do ii=-2*nxb,2*nxb,1
    do jj=-2*nyb,2*nyb,1
     if(ii.ne.0.or.jj.ne.0) then  !! at least one traslation, 0 0 is before
      vadd=ii*basis(1,1:2)+jj*basis(2,1:2)
      xadd=x+vadd(1)
      yadd=y+vadd(2)
      if(xadd.ge.box(1).and.xadd.le.box(2).and.yadd.ge.box(3).and.yadd.le.box(4)) then
       addpoints=addpoints+1
       if(addpoints.eq.nmax1) then
        print*,"too many addpoints"
        stop
       endif
       rgb2(nmax+addpoints,1)=xadd
       rgb2(nmax+addpoints,2)=yadd
       rgb2(nmax+addpoints,3)=thez
      endif
     endif
    enddo
   enddo
      
   if(thez.lt.bottom)bottom=thez
   if(thez.gt.top)top=thez
  else
   dl=dsqrt( (x-p0(1))**2 + (y-p0(2))**2 )
   write(8,333)dl,thez
  endif


enddo

if(.not.stmline)then
 fac=1.d0
 print*,"name colormap"
 read(5,31)fc
 open(unit=iunit,file=fc,status="unknown")
 print*,"starting interpolation, give me refine factor 1(no interp)<f<0.1(extremely heavy) "
 read*,fac
 print*,minval(rgb2(1:nmax+addpoints,3)),maxval(rgb2(1:nmax+addpoints,3))
 call interp_scattered(rgb2(1:nmax+addpoints,1:3),rgb3,fac,dxrgb)
 print*,"completed"
 nx=size(rgb3,1)
 ny=size(rgb3,2)
 select case(nx)
!(    f10.4)
  case(1:9)
   fmti(5:5)=nx
  case(10:99)
   fmti(4:5)=nx
  case(100:999)
   fmti(3:5)=nx
 end select
 write(6,*)fmti
 open(unit=15,file=fo1,status="unknown")
 nxnew=nx-mod(nx,4) +4
 allocate(rgb4(nxnew,ny))
 do i=1,nx
  do j=1,ny
   if(rgb3(i,j).lt.bottom)then
    rgb4(i,j)=bottom
   else if(rgb3(i,j).gt.top) then
    rgb4(i,j)=top
   else
    rgb4(i,j)=rgb3(i,j)
   endif
  enddo
 enddo
 write(15,48)"#minval maxval dx in Angstrom  ", &
       minval(rgb4(1:nx,1:ny))*0.529177d0,maxval(rgb4(1:nx,1:ny))*0.529177d0,dxrgb*0.529177d0
 write(15,49)"#ny rows of nx columns: ",ny,nx
  do j=1,ny
   write(15,fmti)rgb4(1:nx,j)*0.529177d0
  enddo
 close(unit=15)
 if(nxnew.gt.nx)rgb4(nx+1:nxnew,1:ny)=bottom
 print*,minval(rgb4),maxval(rgb4),bottom
 print*,"resized bitmap data: nx= ",nx,nxnew
 call uniform2bmp(rgb4,b,iunit)
 open(unit=19,file=fo,status="unknown")
  call write_bmp(b,19)
 close(unit=19)
endif

close(unit=iunit)

31 format(a)
!33 format("{",f12.6,",",f12.6,",",f12.6,"},")
33 format(3f12.6,2e20.8)
333 format(2f12.6)
34 format(4f12.6)
300 format(i4,a)
302 format(a,2f12.6)
48 format(a,3f12.4)
49 format(a,2i5)

close(unit=8)
close(unit=9)
close(unit=10)
close(unit=12)
!call destroy_geo(g)
call free_cube(c)
if(.not.stmline)then
call free_bmp(b)
 deallocate(rgb2)
 deallocate(rgb3)
 deallocate(rgb4)
endif
if(fip(1:2).ne."XX")call free_cube(pc)
deallocate(lista)

end
